      integer nba,nphase,nka,npmax
      integer iden,igamow,idirconv
      double precision v_source
      integer iicheap,ident
      integer ireduce
      parameter (nba=1,nphase=10000,nka=25,npmax=10000)
      parameter (iden=1,igamow=0,idirconv=1,v_source=0.d0)
      parameter (iicheap=0,ident=1)
      parameter (ireduce=2)
c
c     'nba' refers to the number of impact parameters to be used.
c     Keeping 'nba' no larger than it has to be will reduce the
c     memory needed.  nphase refers to the number of phase space
c     points needed for each impact parameter.  Again keep this to
c     a minimum to reduce the memory needed.  
c     
c     'nka' is the number of momenta for which the correlation function 
c     will be calculated.  The program should prompt you if these 
c     parameters have not been chosen sufficiently large. 
c
c     Choose 'iden=2', if you wish to construct the denominator only using
c     events where 2 or more particles were measured.  I DO NOT
c     recommend doing this but several groups are stuck on it for hardware
c     reasons.  Choose 'npmax' large enough, approximately 25000 or more
c     to make a good sampling of single-particle spectra, but only if using
c     the 'iden=2' option.
c
c     It also is not the usual definition of the correlation function.
c     If one wishes to construct the denom. using all possible events,
c     choose 'iden=1'.  If 'iden=1', you can set npmax arbitrarily small
c     to same memory as none of those arrays are used.
c
c     If one likes Gamow corrected correlations choose igamow=1,
c     otherwise choose 'igamow=0'.
c
c     Choose idirconv to be an integer 1-5, depending on the convention
c     you wish to use for defining the direction and frame for the relative
c     momentum.  See additional explanation/code, in the subroutine
c     "decompose".
c     ---------------------------------------------------------------
c     Choose 'idirconv=1' for convention where 'kx,ky,kz' are defined first 
c     in frame where 'pz1+pz2=0', then boosted outwards to the frame of the
c     pair.  (in this conv. 'k^2=Qinv', and the z direction is parallel
c     to the beam axis)
c     
c     Choose 'idirconv=2 for conv. where one boosts to frame of the pair, 
c     but not the outwards boost. (in this conv. the z-direction is parallel
c     to the beam axis)
c     
c     Choose 'idirconv=3' for conv. where one boosts along the z-axis to
c     a frame specified by 'v_source=constant' (in this conv. the z-direction
c     is along the beam axis) 
c     
c     Choose 'idirconv=4' for conv. where one boosts along the z-axis to
c     a frame specified by 'v_source=constant', and chooses the x-axis
c     parallel to the total momentum (in this conv. the z-axis is not 
c     necessarily parallel to the beam axis, and 'k^2' does not equal 'Qinv^2')
c     
c     Choose 'idirconv=5' for conv. where one does the same as in convention
c     4, only one does one more boost parallel to 'ptot', such that 
c     'k^2=Qinv^2'.
c     ----------------------------------------------------------------
c
c     If 'idirconv' = 3,4 or 5 above, then you need to specify the velocity
c     of the source's frame, 'v_source'.  Note that if you know the rapidity
c     of the source, 'y_source', then 'v_source=tanh(y_source)'.
c
c     Make iicheap=1 if you are using Breit-Wigner form for wave-function.
c     Otherwise, make it zero.  There are Gamow-Teller forms for (K+,K-) 
c     (p,pi+) (d,alpha) (p,alpha).  Each of these forms accounts for only one
c     resonant peak.  Look in the subroutine "cheapset" for more info.
c
c     If "ident" =1 then we are using identical particles
c     or at least the same phase space pt.s for both, and we
c     do not need to set arrays for both types.
c     If the particles are not identical, comment out the
c     equivalence statement in the main program and set "ident"=0.
c
c     Choose 'ireduce=1' if you wish to use the reduced relative
c     momenta to plot '{ (m1*p2-m2*p1)/(m1+m2), = .5*(p2-p1) if 
c     m1=m2 }' or choose 'ireduce=2' if you prefer '{p2-p1}' as the
c     variable to plot. All HE people use the =2 option for pi-pi or K-K.
